/*
Annika Tan

Reference:
  - Rodger's code
  - Ref_WB_Voronoi_3D
  - Ref_WB_SphericalHarmonics
*/


// [I] Import library

import wblut.geom.*;
import wblut.hemesh.*;
import wblut.core.*;
import wblut.math.*;
import wblut.nurbs.*;
import wblut.*;
import wblut.processing.*;

import toxi.audio.*;
import toxi.color.*;
import toxi.color.theory.*;
import toxi.data.csv.*;
import toxi.data.feeds.*;
import toxi.data.feeds.util.*;
import toxi.doap.*;
import toxi.geom.*;
import toxi.geom.mesh.*;
import toxi.geom.mesh.subdiv.*;
import toxi.geom.mesh2d.*;
import toxi.geom.nurbs.*;
import toxi.image.util.*;
import toxi.math.*;
import toxi.math.conversion.*;
import toxi.math.noise.*;
import toxi.math.waves.*;
import toxi.music.*;
import toxi.music.scale.*;
import toxi.net.*;
import toxi.newmesh.*;
import toxi.nio.*;
import toxi.physics2d.*;
import toxi.physics2d.behaviors.*;
import toxi.physics2d.constraints.*;
import toxi.physics3d.*;
import toxi.physics3d.behaviors.*;
import toxi.physics3d.constraints.*;
import toxi.processing.*;
import toxi.sim.automata.*;
import toxi.sim.dla.*;
import toxi.sim.erosion.*;
import toxi.sim.fluids.*;
import toxi.sim.grayscott.*;
import toxi.util.*;
import toxi.util.datatypes.*;
import toxi.util.events.*;
import toxi.volume.*;

import wblut.nurbs.*;
import wblut.hemesh.*;
import wblut.geom.*;
import wblut.core.*;
import wblut.processing.*;
import wblut.math.*;
import java.util.List;

// [II] Declare variables
double theta, phi, r;

List<WB_Point> points;
//WB_Point[] points;
WB_Render3D render;
WB_GeometryFactory gf;

import peasy.*;
PeasyCam camera;

import controlP5.*;
ControlP5 cp5;

Table table;
int rowNums;
int boxSize = 100;
ArrayList<Book> books = new ArrayList<Book>();
float[][] books_points;
int numpoints;
CheckBox checkbox;


//--------------------------------------------//
// [A] Setup
void setup() {
  size(1000, 1000, P3D);
  //fullScreen(P3D);
  smooth(8);
  camera = new PeasyCam(this, 250);
  camera.setYawRotationMode();

  table = loadTable("fem_elements.csv", "header");
  surface.setResizable(true);
  rowNums = table.getRowCount();
  println("Rows: " + rowNums);

  // [i] Spherical Shape
  
   // [ii] **IMPORTANT** Final declare points (x,y,z)
  points=new ArrayList<WB_Point>();
  point_funct();
  println(points.size());
  shape_builder();
  println(points.size());
}
//--------------------------------------------//
// [B] Draw
void draw() {
  background(10); 
  stroke(255,150);
  strokeWeight(3); 
  
  textAlign(CENTER, TOP); 
  textSize(30);
  text("SEATTLE PUBLIC LIBRARY: FEMINISM", 270, 10);
  surface.setTitle("SEATTLE PUBLIC LIBRARY: FEMINISM");
  
  cp5 = new ControlP5(this);
  cp5.setAutoDraw(false);
  checkbox = cp5.addCheckBox("Dewey Class")
        .setPosition(45, 75)
        .setColorForeground(color(100))
        .setColorActive(color(255))
        .setColorLabel(color(255))
        .setSize(10, 10)
        .setItemsPerRow(6)
        .setSpacingColumn(25)
        .setSpacingRow(5)
        .addItem("000", 1)
        .addItem("100", 2)
        .addItem("200", 3)
        .addItem("300", 4)
        .addItem("400", 5)
        .addItem("500", 6)
        .addItem("600", 7)
        .addItem("700", 8)
        .addItem("800", 9)
        .addItem("900", 10)
        .addItem("None", 11)
       ;
  checkbox.activateAll();
  
  translate(width/2, height/2);
  rotateY(map(mouseX, 0, width, -PI, PI));
  rotateX(map(mouseY, 0, height, -PI, PI));
 
  //String s = row.getString("title");   // s has the value “Joyous”
  //row.setInt("x", mouseX); // Update the value of column "x" to mouseX in a given TableRow.
  
  //Set the values of all columns in that row.
  //row.setFloat("title", mouseX);
  //row.setFloat("diameter", random(40, 80));
  //row.setString("title", "new label");
  
  int index = 0; 
  
  for (WB_Point p : points){
    if (index > rowNums) {
      color c = elementDetermine(books.get(index-rowNums).element);
      stroke(c);
          render=new WB_Render3D(this);
    render.drawPoint(p);
    }
    index += 1;
  }
} 